Subject: Re: IMQ bug: kernel reboot immediately

From: Patrick McHardy <[email-masked]>
Date: Fri, 24 Apr 2009 17:29:05 +0200

Salatiel Filho wrote:
> On Fri, Apr 24, 2009 at 12:19, Patrick McHardy <[email-masked]> wrote:
>> Salatiel Filho wrote:
>>> I am just curious , is there a qdisc in mainline that behaves similar
>>> to wrr [weight round robin] ?
>>> http://www.zz9.dk/wrr
>> DRR. But it can't do those strange load-balancing hacks.
>>
> 
> what would it be those strange ugly hacks ? :)

Look at the code. At least they were there last time I had a look.

> Any good place where i can find DRR documentation/examples ?

No, but I can give you an example:

tc qdisc add dev <dev> parent <parent> handle <handle> drr

tc class add dev <dev> parent <handle> classid <classid> drr

repeat class add as often as you need. The default quantum per
class is the MTU, including link layer headers. You can manually
change that by specifying the "quantum" parameter for classes.

As for the flow classifier:

tc filter add dev <dev> protocol all pref 1 parent <handle> \
	flow hash keys key1,key2,... divisor <number of classes>

The DRR classids need to be consequitive for this to work.